%{?scl:%scl_package perl-CPAN}

Name:           %{?scl_prefix}perl-CPAN
Version:        2.05
Release:        311%{?dist}
Summary:        Query, download and build perl modules from CPAN sites
License:        GPL+ or Artistic
Group:          Development/Libraries
URL:            http://search.cpan.org/dist/CPAN/
Source0:        http://www.cpan.org/authors/id/A/AN/ANDK/CPAN-%{version}.tar.gz
# Create site paths for the first time, bug #1158873, CPAN RT#99905
Patch0:         CPAN-2.05-Attemp-to-create-site-library-directories-on-first-t.patch
# Change configuration directory name
Patch1:         CPAN-2.05-Replace-configuration-direcotory-string-with-a-marke.patch
BuildArch:      noarch
BuildRequires:  %{?scl_prefix}perl
BuildRequires:  %{?scl_prefix}perl(Config)
BuildRequires:  %{?scl_prefix}perl(ExtUtils::MakeMaker)
BuildRequires:  %{?scl_prefix}perl(File::Basename)
BuildRequires:  %{?scl_prefix}perl(File::Path)
BuildRequires:  %{?scl_prefix}perl(strict)
BuildRequires:  %{?scl_prefix}perl(vars)
# Optional:
BuildRequires:  %{?scl_prefix}perl(File::Spec)
%if !%{defined perl_bootstrap} && !%{defined perl_small}
BuildRequires:  %{?scl_prefix}perl(YAML::Syck)
%endif

# Run-time:
# Prefer Archive::Tar and Compress::Zlib over tar and gzip
BuildRequires:  %{?scl_prefix}perl(Archive::Tar) >= 1.50
%if !%{defined perl_bootstrap}
BuildRequires:  %{?scl_prefix}perl(Archive::Zip)
%endif
BuildRequires:  %{?scl_prefix}perl(autouse)
BuildRequires:  %{?scl_prefix}perl(base)
BuildRequires:  %{?scl_prefix}perl(Carp)
BuildRequires:  %{?scl_prefix}perl(constant)
BuildRequires:  %{?scl_prefix}perl(Compress::Zlib)
BuildRequires:  %{?scl_prefix}perl(CPAN::Meta::Requirements) >= 2.121
BuildRequires:  %{?scl_prefix}perl(Cwd)
BuildRequires:  %{?scl_prefix}perl(Data::Dumper)
# Devel::Size not used at tests
BuildRequires:  %{?scl_prefix}perl(DirHandle)
BuildRequires:  %{?scl_prefix}perl(Dumpvalue)
BuildRequires:  %{?scl_prefix}perl(Exporter)
# ExtUtils::Manifest not used at tests
BuildRequires:  %{?scl_prefix}perl(Fcntl)
BuildRequires:  %{?scl_prefix}perl(File::Copy)
BuildRequires:  %{?scl_prefix}perl(File::Find)
# File::HomeDir 0.65 not used at tests
BuildRequires:  %{?scl_prefix}perl(File::Spec::Functions)
BuildRequires:  %{?scl_prefix}perl(File::Temp) >= 0.16
BuildRequires:  %{?scl_prefix}perl(FileHandle)
BuildRequires:  %{?scl_prefix}perl(Getopt::Std)
# HTTP::Date is optional, prefer in-core Time::Local
# HTTP::Request is optional
BuildRequires:  %{?scl_prefix}perl(HTTP::Tiny) >= 0.005
BuildRequires:  %{?scl_prefix}perl(if)
BuildRequires:  %{?scl_prefix}perl(lib)
# local::lib is optional
# LWP is optional, prefer HTTP::Tiny and Net::FTP
# LWP::UserAgent is optional
# Mac::BuildTools not needed
# Mac::Files not needed
# Module::Signature is optional
# Net::Config not used at tests
# Net::FTP not used at tests
BuildRequires:  %{?scl_prefix}perl(Net::Ping)
BuildRequires:  %{?scl_prefix}perl(overload)
BuildRequires:  %{?scl_prefix}perl(POSIX)
BuildRequires:  %{?scl_prefix}perl(Safe)
BuildRequires:  %{?scl_prefix}perl(Sys::Hostname)
BuildRequires:  %{?scl_prefix}perl(Term::ReadLine)
BuildRequires:  %{?scl_prefix}perl(Text::ParseWords)
BuildRequires:  %{?scl_prefix}perl(Text::Wrap)
# Time::Local not used at tests
# URI not used at tests
# URI::Escape not used at tests
# URI::URL 0.08 is optional 
# User::pwent not used at tests
BuildRequires:  %{?scl_prefix}perl(warnings)
# Optional:
BuildRequires:  %{?scl_prefix}perl(CPAN::Meta) >= 2.110350
# Digest::MD5 not used at tests
BuildRequires:  %{?scl_prefix}perl(Digest::SHA)
# Keep MIME::Base64 optional
BuildRequires:  %{?scl_prefix}perl(Module::Build)

# Tests:
BuildRequires:  %{?scl_prefix}perl(FindBin)
BuildRequires:  %{?scl_prefix}perl(Pod::Usage)
BuildRequires:  %{?scl_prefix}perl(Test::More)

# Optional tests:
BuildRequires:  %{?scl:%{_root_bindir}}%{?!scl:%{_bindir}}/gpg
# Digest::SHA1 not needed if Digest::SHA is available
# Digest::SHA::PurePerl not needed if Digest::SHA is available
%if !%{defined perl_bootstrap} && !%{defined perl_small}
BuildRequires:  %{?scl_prefix}perl(Expect)
%endif
BuildRequires:  %{?scl_prefix}perl(Hash::Util)
%if !%{defined perl_bootstrap} && !%{defined perl_small}
# Kwalify not yet packaged
BuildRequires:  %{?scl_prefix}perl(Module::Signature) >= 0.66
BuildRequires:  %{?scl_prefix}perl(Perl::Version)
%endif
BuildRequires:  %{?scl_prefix}perl(Socket)
%if !%{defined perl_bootstrap} && !%{defined perl_small}
BuildRequires:  %{?scl_prefix}perl(Sort::Versions)
# Test::MinimumVersion not used
# Test::Perl::Critic not used
BuildRequires:  %{?scl_prefix}perl(Test::Pod) >= 1.00
BuildRequires:  %{?scl_prefix}perl(Test::Pod::Coverage) >= 0.18
BuildRequires:  %{?scl_prefix}perl(YAML) >= 0.60
%endif

Requires:       %{?scl_prefix}perl(:MODULE_COMPAT_%(%{?scl:scl enable %{scl} '}eval "$(perl -V:version)";echo $version%{?scl:'}))
Requires:       %{?scl_prefix}perl(Archive::Tar) >= 1.50
Requires:       %{?scl_prefix}perl(CPAN::Meta::Requirements) >= 2.121
%if !%{defined perl_bootstrap}
Requires:       %{?scl_prefix}perl(Devel::Size)
%endif
Requires:       %{?scl_prefix}perl(ExtUtils::Manifest)
%if !%{defined perl_bootstrap}
Requires:       %{?scl_prefix}perl(File::HomeDir) >= 0.65
%endif
Requires:       %{?scl_prefix}perl(File::Temp) >= 0.16
Requires:       %{?scl_prefix}perl(lib)
Requires:       %{?scl_prefix}perl(Net::Config)
Requires:       %{?scl_prefix}perl(Net::FTP)
Requires:       %{?scl_prefix}perl(POSIX)
Requires:       %{?scl_prefix}perl(Term::ReadLine)
Requires:       %{?scl_prefix}perl(Time::Local)
%if !%{defined perl_bootstrap}
Requires:       %{?scl_prefix}perl(URI)
Requires:       %{?scl_prefix}perl(URI::Escape)
%endif
Requires:       %{?scl_prefix}perl(User::pwent)
# Optional but higly recommended:
%if !%{defined perl_bootstrap}
Requires:       %{?scl_prefix}perl(Archive::Zip)
Requires:       %{?scl_prefix}perl(Compress::Bzip2)
Requires:       %{?scl_prefix}perl(CPAN::Meta) >= 2.110350
%endif
Requires:       %{?scl_prefix}perl(Compress::Zlib)
Requires:       %{?scl_prefix}perl(Digest::MD5)
# CPAN encourages Digest::SHA strongly because of integrity checks
Requires:       %{?scl_prefix}perl(Digest::SHA)
Requires:       %{?scl_prefix}perl(Dumpvalue)
Requires:       %{?scl_prefix}perl(ExtUtils::CBuilder)
%if ! %{defined perl_bootstrap}
# Avoid circular deps local::lib -> Module::Install -> CPAN when bootstraping
# local::lib recommended by CPAN::FirstTime default choice, bug #1122498
Requires:       %{?scl_prefix}perl(local::lib)
%endif
Requires:       %{?scl_prefix}perl(Module::Build)
%if !%{defined perl_bootstrap}
Requires:       %{?scl_prefix}perl(Text::Glob)
%endif
Provides:       %{?scl_prefix}cpan = %{version}

# RPM 4.8 style
%{?filter_setup:
# Filter non-Linux dependencies
%filter_from_requires /^%{?scl_prefix}perl(Mac::BuildTools)/d
# Filter under-specified dependencies
%filter_from_requires /^%{?scl_prefix}perl(CPAN::Meta::Requirements)/d
%?perl_default_filter
}
# RPM 4.9 style
# Filter non-Linux dependencies
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^%{?scl_prefix}perl\\(Mac::BuildTools\\)
# Filter under-specified dependencies
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^%{?scl_prefix}perl\\(CPAN::Meta::Requirements\\)


%description
The CPAN module automates or at least simplifies the make and install of
perl modules and extensions. It includes some primitive searching
capabilities and knows how to use LWP, HTTP::Tiny, Net::FTP and certain
external download clients to fetch distributions from the net.

%prep
%setup -q -n CPAN-%{version}
%patch0 -p1
%patch1 -p1
# Change configuration name
find -type f -exec sed -i -e 's/XCPANCONFIGNAMEX/cpan%{?scl:-%{scl}}/g' {} \;
# Remove bundled modules
rm -r ./inc/*
sed -i -e '/inc\//d' MANIFEST

%build
%{?scl:scl enable %{scl} '}perl Makefile.PL INSTALLDIRS=vendor && make %{?_smp_mflags}%{?scl:'}

%install
%{?scl:scl enable %{scl} '}make pure_install DESTDIR=$RPM_BUILD_ROOT%{?scl:'}
find $RPM_BUILD_ROOT -type f -name .packlist -exec rm -f {} \;
%{_fixperms} $RPM_BUILD_ROOT/*

%check
%{?scl:scl enable %{scl} '}make test%{?scl:'}

%files
%doc Changes PAUSE*.pub README Todo
%{_bindir}/*
%{perl_vendorlib}/*
%{_mandir}/man1/*
%{_mandir}/man3/*

%changelog
* Wed Jan 28 2015 Petr Pisar <ppisar@redhat.com> - 2.05-311
- Change configuration directory name

* Sun Jan 25 2015 Jitka Plesnikova <jplesnik@redhat.com> - 2.05-310
- Rebuild of bootstrapped package

* Thu Jan 22 2015 Petr Pisar <ppisar@redhat.com> - 2.05-309
- Disable optional tests for small build root

* Thu Oct 30 2014 Petr Pisar <ppisar@redhat.com> - 2.05-308
- Create site paths for the first time (bug #1158873)

* Wed Sep 10 2014 Petr Pisar <ppisar@redhat.com> 2.05-307
- Synchronize to perl.spec modifications
- Disable non-core modules when bootstrapping

* Tue Apr 22 2014 Petr Pisar <ppisar@redhat.com> 2.05-1
- Specfile autogenerated by cpanspec 1.78.
